{{ ir_tx_nec_demo.spin

  Bob Belleville

  Demo both transmitter and reader for NEC codes.
  
  see readme.pdf for more documentaton

  2007/03/07 - essentially from scratch
  2007/03/08 - fine tune
               

}}
 
CON

                                'use 80MHz for max resolution
        _clkmode        = xtal1 + pll16x
        _xinfreq        = 5_000_000


    kdPin  = 26          'Kbd pin (1-pin version) (use this pin    if trying on existing circuit)

  _irrpin  = 2      ' ir receiver module on this pin
  _device  = 0      ' accept any IR device code
  _dlyrpt  = 6      ' delay before accepting code as repeat

  _irxpin  = 1      ' transmitter pin

VAR

        
OBJ

        term    : "tv_terminal"
        kb      : "Debug_1pinKBD"                         'debug keyboard driver
        irrx    : "ir_cog"
        irtx    : "ir_tx_nec"


PUB start | kbd, rtn, t, valid

  
  term.start(12)                'start the terminal
{
  term.str(string("Hit <spacebar> to synchronise keyboard "))
  t := kb.calckbdtime(kdpin)       'calculate the keyboard timing 6713,6737 acer keyboard
  term.out(13)
  term.str(string("Timing = "))    '\ optionally show the timing calculated
  term.dec(t & $FFFF)              '|
  term.out(",")                    '|
  term.dec(t >> 16)                '/
  term.out(13)

  kb.start(kdpin, t & $FFFF, t >> 16)       'start the 1pinKbd driver
}
  kb.start(kdpin, 6701 , 6726)    'start the 1pinKbd driver

'  irrx.init(0,0,2,false)        'start the ir reader
  irrx.init(_irrpin,_device,_dlyrpt,true)       'startup  infra red receiver
  irtx.start(1)                 'start the ir transmitter

  term.str(@title)
  term.str(@msg1)
  term.str(@msg2)

  repeat
    if (kbd := kb.rxcheck) <> -1
      kbd &= $7f                        'mask to 7 bits
      nl
      term.hex(kbd,2)                   'from terminal kbd via ir to ir rcv
      irtx.send(kbd<<16 | $a5a5)        ' use $a5a5 as the keyboard frvice code

    valid := -1
    if (valid := rtn := irrx.fifo_get) <> -1     'rcv with ir receiver and dequeue
      sp
      term.out("(")
      term.hex(rtn,2)                       'show keycode rcv'd
      comma
      term.hex(valid := irrx.fifo_get_lastvalid,6) 'show full code rcv'd
      term.out(")")

    if valid <> -1            ' retransmit unknown IR signal
      irtx.send(valid)


PUB sp
  term.out(" ")
PUB comma
  term.out(",")
PUB nl
  term.out(13)
  term.out(10)

    
DAT

title   byte    "ir_tx_nec_demo.spin",13,10,0
msg1    byte    "typed keys are sent ir and rcv'd ir",13,10,0
msg2    byte    "type away:",13,10,0  
msg3    byte    "any key to begin",13,10,0
